//+------------------------------------------------------------------+
//|                                                     mWay.mq4 |
//+------------------------------------------------------------------+

//Indicators that need to be running:
//AscTrendline
//VQ

#property copyright ""
#property link      ""

//---- input parameters
extern bool       EnableEMailAlert=false;
//extern int       StartTime=0;
//extern int       StopTime=0;
//extern bool      OpenTrade=true;
//extern int       TrailingStop=0;
//extern int       StopLoss=0;

static bool       bMACDPositive=true;     //false:red over turq true:turq over red
static double     dVQ5313Up=0;            //-1:down(red) 0:neutral(transition) 1:up(green)
static double     dVQ3313Up=0;            //-1:down(red) 0:neutral(transition) 1:up(green)
static double     dAscTrendUp=0;          //-1:down(red) 0:neutral(green) 1:up(blue)
static bool       bNotified=false;        //For testing.  Only send message once
static bool       bBuyMode=false;

//static int m,h,mPrev,hPrev;

//+------------------------------------------------------------------+

int init()
  {
//   m=TimeMinute(CurTime());
//   mPrev=m;
//   h=TimeHour(CurTime());
//   hPrev=h;
   return(0);
  }
  
//+------------------------------------------------------------------+

int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+

int start()
   {
   double   dAscUTrend,dAscDTrend;
   int      i,handle;
   string   sTemp;
   
//   m=TimeMinute(CurTime());
//   h=TimeHour(CurTime());
   
   //-----------------------Calculate MACD Up/Down------------------------------------------------  
   //Going to wait for newly forming bar before reporting, so use Shift of 1 (previous bar)
   if(iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1)>iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1)) 
      {
      bMACDPositive=true;
      sTemp="1";
      }
   else 
      {
      bMACDPositive=false;
      sTemp="-1";
      }

   //----------------------Calculate Volatility Quality (VQ) Up/Down-----------------------------
   //dVQ5313Up, dVQ3313Up   -1:Down(red) 0:Neutral(transition) 1:Up(green)
      
      double VQResult1=iCustom(NULL,0,"VQ",3,3,1,3,true,true,1000,1,0);
      double VQResult2=iCustom(NULL,0,"VQ",3,3,1,3,true,true,1000,2,0);
      if(VQResult1==VQResult2){dVQ3313Up=0;}
      else
         {
         if(VQResult1<VQResult2){dVQ3313Up=1;}
         else {dVQ3313Up=-1;}
         }

      double VQResult3=iCustom(NULL,0,"VQ",5,3,1,3,true,true,1000,1,0);
      double VQResult4=iCustom(NULL,0,"VQ",5,3,1,3,true,true,1000,2,0);
      if(VQResult3==VQResult4){dVQ5313Up=0;}
      else
         {
         if(VQResult3<VQResult4){dVQ5313Up=1;}
         else {dVQ5313Up=-1;}
         }

   //----------------------Calculate ASC Trend Up (blue), Down (red), or undetermined (green)-----
   //If dAscUTrend > dAscDTrend, then Blue.  If dAscUTrend < dAscDTrend, then Red.  if =, then Green!
   //Also, file updated, mAscBarColor.csv with each tick. 0:Neutral(Green), 1:Up(Blue), -1:Down(Red)
   //dAscTrendUp 0:Neutral(green) 1:Up(blue) -1:Down(red)

   dAscUTrend=iCustom(NULL,0,"AscTrendline",9,0.3,1,1,1,0,1000,6,0);    //Buffer 6, Bar[0] Current Bar 
   dAscDTrend=iCustom(NULL,0,"AscTrendline",9,0.3,1,1,1,0,1000,7,0);
   if(dAscUTrend>dAscDTrend){dAscTrendUp=1;}
   else
      if(dAscUTrend<dAscDTrend){dAscTrendUp=-1;}
      else {dAscTrendUp=0;}
   
   //----------------------Trade Decision------------------------------------------------------

      if(!bBuyMode)
         {
         sTemp=Symbol()+ " - "+Period()+" - "+DoubleToStr(Bid,4)+"/"+DoubleToStr(Ask,4);
         if((dVQ5313Up==1)&&(dVQ3313Up==1)&&(dAscTrendUp==1)&&bMACDPositive)
            {
            Alert("New Buy Signal (4/4)! "+Symbol()+" - "+Period());
            if(EnableEMailAlert){SendMail("New BUY Signal!","New Buy Signal (4/4)! "+sTemp);}
            bBuyMode=true;
            }
         else
            {
            if((dVQ5313Up==1)&&(dVQ3313Up==1)&&(dAscTrendUp==1)&&!bMACDPositive)
               {
               Alert("New Buy Signal (3/4)! "+Symbol()+" - "+Period());
               if(EnableEMailAlert){SendMail("New BUY Signal!","New Buy Signal (3/4)! "+sTemp);}
               bBuyMode=true;
               }
            }
         }
      else
         {
         sTemp=Symbol()+ " - "+Period()+" - "+DoubleToStr(Bid,4)+"/"+DoubleToStr(Ask,4);
         if((dVQ5313Up==-1)&&(dVQ3313Up==-1)&&(dAscTrendUp==-1)&&!bMACDPositive)
            {
            Alert("New Sell Signal (4/4)! "+Symbol()+" - "+Period());
            if(EnableEMailAlert){SendMail("New MW SELL Signal!","New Sell Signal (4/4)! "+sTemp);}
            bBuyMode=false;
            }
         else
            {
            if((dVQ5313Up==-1)&&(dVQ3313Up==-1)&&(dAscTrendUp==-1)&&bMACDPositive)
               {
               Alert("New Sell Signal (3/4)! "+Symbol()+" - "+Period());
               if(EnableEMailAlert){SendMail("New MW SELL Signal!","New Sell Signal (3/4)! "+sTemp);}
               bBuyMode=false;
               }
            }
         }

   //Create Status file - Needed for VB6 Dashboard
   double dProfit=0;
   int itotal=OrdersTotal();
   for(i=0;i<itotal;i++)
      {
      if(OrderSelect(i,SELECT_BY_POS)==false) continue;
      dProfit=dProfit+OrderProfit();
      }
   handle=FileOpen("Status"+Symbol()+".csv",FILE_CSV|FILE_WRITE,',');
   if(bMACDPositive){sTemp="1,";}
   else {sTemp="-1,";}
   sTemp=sTemp+DoubleToStr(dAscTrendUp,0)+","+DoubleToStr(dVQ5313Up,0)+","+DoubleToStr(dVQ3313Up,0)+","+DoubleToStr(dProfit,2)+","+TimeToStr(CurTime(),TIME_DATE|TIME_SECONDS);
   if(handle>0)
      {
      FileWrite(handle, sTemp);
      FileClose(handle);
      }
   return(0);
   }

